SystemOrganization addCategory: #SPN!

TestCase subclass: #SPNTests
	instanceVariableNames: 'substitution_fct permutation_fct keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SPN'!

!SPNTests commentStamp: 'Lolita 5/9/2017 08:30' prior: 0!
I contain all the tests concerning the correctness of the methods of the  class SPN .

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	keys:		<Object>
	permutation_fct:		<Object>
	substitution_fct:		<Object>


    Implementation Points!

!SPNTests methodsFor: 'accessing' stamp: 'Lolita 5/9/2017 08:35'!
testEncrypt
	self
		assert: (SPN new encrypt: '0010011010110111')
		equals: '1011110011010110'! !

Object subclass: #SPN
	instanceVariableNames: 'substitution_fct permutation_fct keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SPN'!

!SPN commentStamp: 'Lolita 5/9/2017 07:17' prior: 0!
I'm an iterated encryption algorithm. I'm constructed for strings consisting of 0s and 1s, and which size is 16.
I can encrypt strings with the method key:with.

You can modify my substitution and permutation functions with the methods substitution_fct: and permutation_fct:.

Example:
SPN new encrypt: '0010011010110111'
!

!SPN methodsFor: 'as yet unclassified' stamp: 'Lolita 5/9/2017 08:19'!
encrypt: aString
	"answers a string encrypted by the SPN algorithm"

	| int_string substitution_s key_incorporated_s encrypted_s|
	int_string := aString.
	Transcript cr; show: 'Intermediate string (w0): '; show: int_string.
	
	1 to: 3 do: [ :each | 
		key_incorporated_s := self key: (self keys at: each) with: int_string.
		Transcript cr; show: 'KeyIncorporated string (u',  each asString , '): '; show: key_incorporated_s.
		
		substitution_s := ''.
		1 to: 4 do: [ :each1 | 
			substitution_s := substitution_s , (self substitution_fct
				at: ( key_incorporated_s copyFrom: ((4 * (each1 - 1)) + 1) to: 4 * each1 ) )
				 ].
		Transcript cr; show: 'Subtitution string (v', each asString, '): '; show: substitution_s.	
			
		int_string := '0000000000000000'.
		1 to: 16 do: [ :each2 | int_string at: each2 put: (substitution_s at: (permutation_fct at: each2))].
		Transcript cr; show: 'Intermediate string (w', each asString , '): '; show: int_string.
	].
	
	key_incorporated_s := self key: (self keys at: 4) with: int_string.
	Transcript cr; show: 'KeyIncorporated string (u4): '; show: key_incorporated_s.
	
	substitution_s := ''.
	1 to: 4 do: [ :each1 | 
			substitution_s := substitution_s , (self substitution_fct
				at: (key_incorporated_s copyFrom: ((4 * (each1 - 1)) + 1) to: 4 * each1 ) ) ].
	Transcript cr; show: 'Subtitution string (v4): '; show: substitution_s.	
	
	encrypted_s := self key: (self keys at: 5) with: substitution_s .
	Transcript cr; cr; show: 'Encrypted string (y): '; show: encrypted_s.
	
	^ encrypted_s 
	
! !

!SPN methodsFor: 'initialization' stamp: 'Lolita 5/8/2017 20:26'!
initialize
	substitution_fct := Dictionary new.
	substitution_fct
		at: '0000' put: '1110';
		at: '0001' put: '0100';
		at: '0010' put: '1101';
		at: '0011' put: '0001';
		at: '0100' put: '0010';
		at: '0101' put: '1111';
		at: '0110' put: '1011';
		at: '0111' put: '1000';
		at: '1000' put: '0011';
		at: '1001' put: '1010';
		at: '1010' put: '0110';
		at: '1011' put: '1100';
		at: '1100' put: '0101';
		at: '1101' put: '1001';
		at: '1110' put: '0000';
		at: '1111' put: '0111'.
	permutation_fct := Dictionary new.
	permutation_fct
		at: 1 put: 1;
		at: 2 put: 5;
		at: 3 put: 9;
		at: 4 put: 13;
		at: 5 put: 2;
		at: 6 put: 6;
		at: 7 put: 10;
		at: 8 put: 14;
		at: 9 put: 3;
		at: 10 put: 7;
		at: 11 put: 11;
		at: 12 put: 15;
		at: 13 put: 4;
		at: 14 put: 8;
		at: 15 put: 12;
		at: 16 put: 16.
	keys := OrderedCollection new.
	keys
		add: '0011101010010100';
		add: '1010100101001101';
		add: '1001010011010110';
		add: '0100110101100011';
		add: '1101011000111111'! !

!SPN methodsFor: 'as yet unclassified' stamp: 'Lolita 5/9/2017 07:54'!
key: aKey with: aString
	"Returns the string consisting at each character in the XOR of the key and the given string"
	
	| result |
	result := '0000000000000000'.
	1 to: 16 do: [ :each |
		( aKey at: each )	= ( aString at: each ) ifTrue: [ result at: each put: $0 ] ifFalse: [ result at: each put: $1 ]
	].
	
	^ result ! !

!SPN methodsFor: 'accessing' stamp: 'Lolita 5/9/2017 04:50'!
keys 
	^ keys! !

!SPN methodsFor: 'accessing' stamp: 'Lolita 5/9/2017 04:51'!
permutation_fct
	^ permutation_fct ! !

!SPN methodsFor: 'accessing' stamp: 'Lolita 5/9/2017 07:17'!
permutation_fct: aDictionnary
	permutation_fct := aDictionnary ! !

!SPN methodsFor: 'accessing' stamp: 'Lolita 5/9/2017 04:50'!
substitution_fct
	^ substitution_fct ! !

!SPN methodsFor: 'accessing' stamp: 'Lolita 5/9/2017 07:17'!
substitution_fct: aDictionnary
	substitution_fct := aDictionnary ! !
